<TeXmacs|1.0.7.20>

<style|<tuple|beamer|vdh|mathemagix>>

<\body>
  <\hide-preamble>
    <assign|pseudo-code|<\macro|body>
      <\padded-normal|1fn|1fn>
        <\indent>
          <\with|par-first|0fn|par-par-sep|0fn|font-size|0.917>
            <\ridged-paper>
              <surround||<right-flush>|<arg|body>>
            </ridged-paper>
          </with>
        </indent>
      </padded-normal>
    </macro>>

    <assign|blacken|<macro|x|<with|ornament-color|black|color|#c0ffc0|strong-color|#f0ffb0|math-color|#ffd4c0|ornament-sunny-color|dark
    grey|ornament-shadow-color|grey|<ornament|<arg|x>>>>>

    <assign|monitor|<\macro|body>
      <\padded-normal|1fn|1fn>
        <\indent>
          <\with|par-first|0fn|par-par-sep|0fn|font-size|0.917|font-family|tt>
            <\blacken>
              <surround||<right-flush>|<arg|body>>
            </blacken>
          </with>
        </indent>
      </padded-normal>
    </macro>>

    \;
  </hide-preamble>

  <screens|<\shown>
    <tit|The <name|Mathemagix> compiler>

    <\with|par-mode|center>
      <tabular*|<tformat|<cwith|4|4|2|2|cell-tsep|2spc>|<table|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|>|<cell|<block*|<tformat|<cwith|1|1|1|1|cell-background|white>|<cwith|1|1|1|1|cell-lsep|1em>|<cwith|1|1|1|1|cell-rsep|1em>|<cwith|1|1|1|1|cell-bsep|1em>|<cwith|1|1|1|1|cell-tsep|1em>|<table|<row|<cell|<image|texmacs-chip.png|0.6w|0.6h||>>>>>>>|<cell|>>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|>|<cell|Joris
      van der Hoeven, Palaiseau 2011>|<cell|>>|<row|<cell|>|<cell|<verbatim|http://www.<anim-repeat|<anim-compose|<anim-constant|<with|color|brown|T<rsub|<space|-0.2spc><with|math-level|0|font-shape|small-caps|e>>X><with|color|dark
      green|<rsub|<with|math-level|0|font-shape|small-caps|macs>>>|1sec>|<anim-constant|<with|color|dark
      green|T<rsub|<space|-0.2spc><with|math-level|0|font-shape|small-caps|<with|color|brown|e>>>X><with|color|brown|<rsub|<with|math-level|0|font-shape|small-caps|macs>>>|1sec>>>.org>>|<cell|>>>>>
    </with>
  </shown>|<\hidden>
    <tit|Motivation>

    <\itemize>
      <unroll|<\shown>
        <vspace*|0.5fn><item>Existing computer algebra systems are slow for
        numerical algorithms

        <math|\<rightsquigarrow\>> we need a compiled language
      </shown>|<\hidden*>
        <item>Low level systems (<name|Gmp>, <name|Mpfr>, <name|Flint>)
        painful for compound objects

        <math|\<rightsquigarrow\>> we need a mathematically expressive
        language
      </hidden*>|<\hidden*>
        <switch|<\shown>
          <item>More and more complex architectures (SIMD, multicore, web)

          <math|\<rightsquigarrow\>> general efficient algorithms cannot be
          designed by hand
        </shown>|<\hidden>
          <item>More and more complex architectures (SIMD, multicore, web)

          Non standard but efficient numeric types

          <math|\<rightsquigarrow\>> general efficient algorithms cannot be
          designed by hand
        </hidden>>
      </hidden*>|<\hidden*>
        <switch|<\shown>
          <item>Existing systems lack sound semantics

          <math|\<rightsquigarrow\>> we need mathematically clean interfaces
        </shown>|<\hidden>
          <item>Existing computer algebra systems lack sound semantics

          Difficult to connect different systems in a sound way

          <math|\<rightsquigarrow\>> we need mathematically clean interfaces
        </hidden>>
      </hidden*>>
    </itemize>
  </hidden>|<\hidden>
    <tit|Main design goals>

    <\itemize>
      <unroll|<\shown>
        <vspace*|0.5fn><item>Strongly typed functional language
      </shown>|<\hidden*>
        <item>Access to low level details and encapsulation
      </hidden*>|<\hidden*>
        <item>Inter-operability with C/C++ and other languages
      </hidden*>|<\hidden*>
        <item>Large scale programming <em|via> intuitive, strongly local
        writing style
      </hidden*>|<\hidden*>
        \;

        <\with|par-left|0cm>
          <\granite>
            <\render-theorem|Guiding principle>
              \;

              <tabular|<tformat|<table|<row|<cell|Prototype>|<cell|>|<cell|<math|\<leftrightsquigarrow\>>>|<cell|>|<cell|Mathematical
              theorem>>|<row|<cell|Implementation>|<cell|>|<cell|<math|\<leftrightsquigarrow\>>>|<cell|>|<cell|Formal
              proof>>>>>
            </render-theorem>
          </granite>
        </with>
      </hidden*>>
    </itemize>
  </hidden>|<\hidden>
    <tit|Example>

    <\mmx-code>
      forall (R: Ring) square (x: R) == x * x;
    </mmx-code>

    <switch|<\shown>
      \;
    </shown>|<\hidden>
      <large|<vspace*|0.5fn><strong|Mathemagix>>

      <\mmx-code>
        category Ring == {

        \ \ convert: Int -\<gtr\> This;

        \ \ prefix -: This -\<gtr\> This;

        \ \ infix +: (This, This) -\<gtr\> This;

        \ \ infix -: (This, This) -\<gtr\> This;

        \ \ infix *: (This, This) -\<gtr\> This;

        }
      </mmx-code>
    </hidden>|<\hidden>
      <large|<vspace*|0.5fn><strong|C++>>

      <\cpp-code>
        template\<less\>typename R\<gtr\>

        square (const R& x) {

        \ \ return x * x;

        }
      </cpp-code>
    </hidden>|<\hidden>
      <large|<vspace*|0.5fn><strong|C++>>

      <\cpp-code>
        <with|color|red|concept> Ring\<less\>typename R\<gtr\> {

        \ \ R::R (int);

        \ \ R::R (const R&);

        \ \ R operator - (const R&);

        \ \ R operator + (const R&, const R&);

        \ \ R operator - (const R&, const R&);

        \ \ R operator * (const R&, const R&);

        }

        \;

        template\<less\>typename R\<gtr\>

        <with|color|red|requires> Ring\<less\>R\<gtr\>

        operator * (const R& x) {

        \ \ return x * x;

        }
      </cpp-code>
    </hidden>|<\hidden>
      <large|<vspace*|0.5fn><strong|Axiom, Aldor>>

      <\mmx-code>
        <with|color|dark magenta|define> Ring: Category == with {

        \ \ 0: %;

        \ \ 1: %;

        \ \ -: % -\<gtr\> %;

        \ \ +: (%, %) -\<gtr\> %;

        \ \ -: (%, %) -\<gtr\> %;

        \ \ *: (%, %) -\<gtr\> %;

        }

        \;

        Square (R: Ring): with {

        \ \ square: R -\<gtr\> R;

        } == <with|color|dark magenta|add> {

        \ \ square (x: R): R == x * x;

        }

        \;

        import from Square (Integer);
      </mmx-code>
    </hidden>|<\hidden>
      <large|<vspace*|0.5fn><strong|Ocaml>>

      <\verbatim-code>
        <with|color|red|#> let square x = x * x;;

        <with|color|dark blue|val square: int -\<gtr\> int> =
        \<less\>fun\<gtr\>

        \;

        <with|color|red|#> let square_float x = x *. x;;

        <with|color|dark blue|val square_float: float -\<gtr\> float> =
        \<less\>fun\<gtr\>
      </verbatim-code>
    </hidden>|<\hidden>
      <large|<vspace*|0.5fn><strong|Ocaml>>

      <\verbatim-code>
        <with|color|red|#> module type RING =

        \ \ \ \ sig

        \ \ \ \ \ \ type t

        \ \ \ \ \ \ val cst : int -\<gtr\> t

        \ \ \ \ \ \ val neg : t -\<gtr\> t

        \ \ \ \ \ \ val add : t -\<gtr\> t -\<gtr\> t

        \ \ \ \ \ \ val sub : t -\<gtr\> t -\<gtr\> t

        \ \ \ \ \ \ val mul : t -\<gtr\> t -\<gtr\> t

        \ \ \ \ end;;

        \;

        <with|color|red|#> module Squarer =

        \ \ functor (El: RING) -\<gtr\>

        \ \ \ \ struct

        \ \ \ \ \ \ let square x = El.mul x x

        \ \ \ \ end;;

        \;

        <with|color|red|#> module IntRing =

        \ \ \ \ struct

        \ \ \ \ \ \ type t = int

        \ \ \ \ \ \ let cst x = x

        \ \ \ \ \ \ let neg x = - x

        \ \ \ \ \ \ let add x y = x + y

        \ \ \ \ \ \ let sub x y = x - y

        \ \ \ \ \ \ let mul x y = x * y

        \ \ \ \ end;;

        \;

        <with|color|red|#> module IntSquarer = Squarer(IntRing);;

        \;

        <with|color|red|#> IntSquarer.square 11111;;

        <with|color|dark blue|-> : int = 123454321
      </verbatim-code>
    </hidden>>
  </hidden>|<\hidden>
    <tit|Language overview: functional programming>

    <\mmx-code>
      shift (x: Int) (y: Int): Int == x + y;

      \;

      v: Vector Int == map (shift 123, [ 1 to 100 ]);

      \;

      test (i: Int): (Int -\<gtr\> Int) == {

      \ \ f (): (Int -\<gtr\> Int) == g;

      \ \ g (j: Int): Int == i * j;

      \ \ return f ();

      }
    </mmx-code>
  </hidden>|<\hidden>
    <tit|Language overview: overloading>

    <unroll|<\shown>
      <\mmx-code>
        category Type == {}

        \;

        forall (T: Type) f (x: T): T == x;

        f (x: Int): Int == x * x;

        f (x: Double): Double == x * x * x * x;

        \;

        mmout \<less\>\<less\> f ("Hallo") \<less\>\<less\> "\\n";

        mmout \<less\>\<less\> f (11111) \<less\>\<less\> "\\n";

        mmout \<less\>\<less\> f (1.1) \<less\>\<less\> "\\n";
      </mmx-code>
    </shown>|<\hidden*>
      <\monitor>
        Castafiore:basic vdhoeven$ ./overload_test

        Hallo

        123454321

        1.4641

        Castafiore:basic vdhoeven$
      </monitor>
    </hidden*>>
  </hidden>|<\hidden>
    <tit|Language overview: classes>

    <\mmx-code>
      class Point == {

      \ \ mutable x: Int;

      \ \ mutable y: Int;

      \ \ 

      \ \ constructor point (a: Int, b: Int) == {

      \ \ \ \ x == a; y == b; }

      \ \ 

      \ \ mutable method translate (dx: Int, dy: Int): Void == {

      \ \ \ \ x := x + dx; y := y + dy; }

      }

      \;

      flatten (p: Point): Syntactic ==

      \ \ 'point (flatten f.x, flatten f.y);

      \;

      infix + (p: Point, q: Point): Point ==

      \ \ point (p.x + q.x, p.y + q.y);
    </mmx-code>
  </hidden>|<\hidden>
    <tit|Language overview: implicit conversions>

    <\mmx-code>
      convert (x: Double): Floating == mpfr_as_floating x;

      \;

      forall (R: Ring)

      upgrade (x: R): Complex R == complex (x, 0);

      // allows for conversion Double --\<gtr\> Complex Floating

      \;

      convert (p: Point): Vector Int == [ p.x, p.y ];

      downgrade (p: Colored_point): Point == point (p.x, p.y);

      // allows for conversion Colored_point --\<gtr\> Vector Int

      // abstract way to implement class inheritance
    </mmx-code>
  </hidden>|<\hidden>
    <tit|Language overview: categories>

    <\mmx-code>
      category Ring == {

      \ \ convert: Int -\<gtr\> This;

      \ \ prefix -: This -\<gtr\> This;

      \ \ infix +: (This, This) -\<gtr\> This;

      \ \ infix -: (This, This) -\<gtr\> This;

      \ \ infix *: (This, This) -\<gtr\> This;

      }

      \;

      category Module (R: Ring) == {

      \ \ prefix -: This -\<gtr\> This;

      \ \ infix +: (This, This) -\<gtr\> This;

      \ \ infix -: (This, This) -\<gtr\> This;

      \ \ infix *: (R, This) -\<gtr\> This;

      }

      \;

      forall (R: Ring, M: Module R)

      square_multiply (x: R, y: M): M == (x * x) * y;

      \;

      mmout \<less\>\<less\> square_multiply (3, 4) \<less\>\<less\> "\\n";
    </mmx-code>
  </hidden>|<\hidden>
    <tit|Language overview: foreign imports>

    <\mmx-code>
      include "basix/categories.mmx";

      \;

      foreign cpp import {

      \ \ cpp_flags \ \ "\0numerix-config --cppflags\0";

      \ \ cpp_libs \ \ \ "\0numerix-config --libs\0";

      \ \ cpp_include "numerix/complex.hpp";

      \;

      \ \ class Complex (R: Ring) == complex R;

      \;

      \ \ forall (R: Ring) {

      \ \ \ \ complex: R -\<gtr\> Complex R == keyword constructor;

      \ \ \ \ complex: (R, R) -\<gtr\> Complex R == keyword constructor;

      \ \ \ \ upgrade: R -\<gtr\> Complex R == keyword constructor;

      \ \ \ \ Re: Complex R -\<gtr\> R == Re;

      \ \ \ \ Im: Complex R -\<gtr\> R == Im;

      \ \ \ \ 

      \ \ \ \ prefix -: Complex R -\<gtr\> Complex R == prefix -;

      \ \ \ \ square: Complex R -\<gtr\> Complex R == square;

      \ \ \ \ infix +: (Complex R, Complex R) -\<gtr\> Complex R == infix +;

      \ \ \ \ infix -: (Complex R, Complex R) -\<gtr\> Complex R == infix -;

      \ \ \ \ infix *: (Complex R, Complex R) -\<gtr\> Complex R == infix *;

      \ \ }

      \ \ 

      \ \ forall (R: Field) {

      \ \ \ \ infix /: (Complex R, Complex R) -\<gtr\> Complex R == infix /;

      \ \ \ \ infix /: (R, Complex R) -\<gtr\> Complex R == infix /;

      \ \ \ \ infix /: (Complex R, R) -\<gtr\> Complex R == infix /;

      \ \ }

      }
    </mmx-code>
  </hidden>|<\hidden>
    <tit|Language overview: foreign exports>

    <\mmx-code>
      foreign cpp export {

      \ \ category Ring == {

      \ \ \ \ convert: Int -\<gtr\> This == inplace set_as;

      \ \ \ \ prefix -: This -\<gtr\> This == prefix -;

      \ \ \ \ infix +: (This, This) -\<gtr\> This == infix +;

      \ \ \ \ infix -: (This, This) -\<gtr\> This == infix -;

      \ \ \ \ infix *: (This, This) -\<gtr\> This == infix *;

      \ \ }

      }
    </mmx-code>
  </hidden>|<\hidden>
    <tit|Language overview: value parameters>

    <\mmx-code>
      class Vec (R: Ring, n: Int) == {

      \ \ private mutable rep: Vector R;

      \ \ 

      \ \ constructor vec (v: Vector R) == {

      \ \ \ \ rep == v; }

      \ \ constructor vec (c: R) == {

      \ \ \ \ rep == [ c \| i: Int in 0..n ]; }

      }

      \;

      forall (R: Ring, n: Int) {

      \ \ flatten (v: Vec (R, n)): Syntactic == flatten v.rep;

      \ \ postfix [] (v: Vec (R, n), i: Int): R == v.rep[i];

      \ \ postfix [] (v: Alias Vec (R, n), i: Int): Alias R == v.rep[i];

      \ \ infix + (v1: Vec (R, n), v2: Vec (R, n)): Vec (R, n) ==

      \ \ \ \ vec ([ v1[i] + v2[i] \| i: Int in 0..n ]);

      \;

      \ \ assume (R: Ordered)

      \ \ infix \<less\>= (v1: Vec (R, n), v2: Vec (R, n)): Boolean ==

      \ \ \ \ big_and (v1[i] \<less\>= v2[i] \| i: Int in 0..n);

      }
    </mmx-code>
  </hidden>|<\hidden>
    <tit|Type system: logical and penalty types>

    <\description>
      <unroll|<\shown>
        <item*|Overloading>Explicit types for overloaded objects

        <\mmx-code>
          forall (T: Type) f (x: T): T == x;

          f (x: Int): Int == x * x;
        </mmx-code>

        Type of <mmx|<with|color|blue|f>>: <verbatim|<with|color|dark
        green|And (Forall (T: Type, T -\<gtr\> T), Int -\<gtr\> Int)>>

        Logical types: <math|f\<of\>And<around*|(|T,U|)>\<Longleftrightarrow\>f\<of\>T\<wedge\>f\<of\>U>
      </shown>|<\hidden*>
        <vspace*|0.5fn><item*|Penalties for overloading and conversions>

        <\mmx-code>
          <greyed|penalty (access)>

          postfix []: (Alias Vector C, Int) -\<gtr\> Alias C == write_access;

          postfix []: (Vector C, Int) -\<gtr\> Vector C == read_access;
        </mmx-code>

        When <strong|reading> an entry of a <strong|mutable> vector, the
        second method is preferred.

        Penalty types: <mmx|<with|color|dark green|Penalty (access, (Alias
        Vector C, Int) -\<gtr\> Alias C)>>
      </hidden*>>
    </description>
  </hidden>|<\hidden>
    <tit|Type system: ambiguities>

    <\description>
      <unroll|<\shown>
        <item*|Partial ordering on (synthetic compound) penalties>

        <\mmx-code>
          p: Polynomial C == ...;

          z: Complex C == ...;

          mmout \<less\>\<less\> p + z \<less\>\<less\> "\\n";

          // ERROR: Polynomial Complex C or Complex Polynomial C?
        </mmx-code>

        Penalties <math|<around*|(|convert,none|)>> and
        <math|<around*|(|none,convert|)>> are incomparable.
      </shown>|<\hidden*>
        <vspace*|0.5fn><item*|Apply best first>

        <\mmx-code>
          v: Vector Integer == [ 1 to 10 ];

          w: Vector Rational == map (square, v);

          // use square on Integer or Rational entries?
        </mmx-code>

        Solution: we perform <mmx|map (square :\<gtr\> (Integer -\<gtr\>
        Integer), v)>

        Prefer <math|none;convert> to <math|convert;none>.
      </hidden*>>
    </description>
  </hidden>|<\hidden>
    <tit|Efficiency: no garbage collection>

    <\mmx-code>
      shift (x: Int) (y: Int): Int == x + y;
    </mmx-code>

    <\cpp-code>
      <\with|font-base-size|10>
        static function_1\<less\>int, const int& \<gtr\>
        <with|color|blue|LAMBDA_NEW_pGU1> (const int &x_1);

        \;

        function_1\<less\>int, const int& \<gtr\>

        <with|color|blue|shift_GU1> (const int &x_1) {

        \ \ return LAMBDA_NEW_pGU1 (x_1);

        }

        \;

        struct <with|color|dark green|LAMBDA_NEW_pGU1_rep>: public
        function_1_rep\<less\>int, const int& \<gtr\> {

        \ \ int x_1;

        \ \ 

        \ \ int

        \ \ <with|color|blue|apply> (const int &y_1) {

        \ \ \ \ return x_1 + y_1;

        \ \ }

        \ \ 

        \ \ inline <with|color|dark green|LAMBDA_NEW_pGU1_rep> (const int
        &x_1_bis): x_1 (x_1_bis) {}

        };

        \;

        static function_1\<less\>int, const int& \<gtr\>

        <with|color|blue|LAMBDA_NEW_pGU1> (const int &x_1) {

        \ \ return function_1\<less\>int, const int& \<gtr\> (new
        LAMBDA_NEW_pGU1_rep (x_1));

        }
      </with>
    </cpp-code>
  </hidden>|<\hidden>
    <tit|Efficiency: low level access>

    <\mmx-code>
      <\small>
        foreign cpp import {

        \ \ cpp_preamble "#define ptr(x,n) (x)*";

        \ \ 

        \ \ class Array (T: Type, n: Int) == (cpp_macro ptr) (T, n);

        \ \ 

        \ \ forall (T: Type, n: Int) {

        \ \ \ \ postfix [] (v: Array (T, n), i: Int): T == postfix [];

        \ \ \ \ postfix [] (v: Alias Array (T, n), i: Int): Alias T ==
        postfix [];

        \ \ }

        }
      </small>

      \;

      forall (R: Ring, n: Int) {

      \ \ inplace prefix - (d: Alias Array (T, n), s: Array (T, n)) ==

      \ \ \ \ for i: Int in 0..n do d[i] := -s[i];

      }
    </mmx-code>
  </hidden>|<\hidden>
    <tit|Efficiency: implementation of categories I>

    <\mmx-code>
      category Magma == {

      \ \ infix *: (This, This) -\<gtr\> This;

      }
    </mmx-code>

    <switch|<\shown>
      <strong|Virtual representation base class for magmas>

      <\cpp-code>
        <\small>
          typedef generic Magma_EL_1;

          \;

          struct Magma_1_rep: public rep_struct {

          \ \ virtual Magma_EL_1 sample_1 () const;

          \ \ virtual Magma_EL_1 TT_1 (const Magma_EL_1 &TT_ARG1_5,

          \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ const
          Magma_EL_1 &TT_ARG2_5) const;

          \ \ inline Magma_1_rep ();

          \ \ virtual inline ~Magma_1_rep ();

          };

          \;

          Magma_EL_1

          Magma_1_rep::sample_1 () const {

          \ \ generic ();

          }

          \;

          Magma_EL_1

          Magma_1_rep::TT_1 (const Magma_EL_1 &TT_ARG1_5,

          \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ const Magma_EL_1 &TT_ARG2_5)
          const {

          \ \ throw string ("not implemented");

          }

          \;

          inline Magma_1_rep::Magma_1_rep () {}

          inline Magma_1_rep::~Magma_1_rep () {}
        </small>
      </cpp-code>
    </shown>|<\hidden>
      <strong|Public magma class as pointer to representation class>

      <\cpp-code>
        <\small>
          struct Magma_1 {

          \ \ Magma_1_rep *rep;

          \ \ inline Magma_1 (): rep (new Magma_1_rep ()) {}

          \ \ 

          \ \ inline ~Magma_1 () {

          \ \ \ \ DEC_COUNT (rep);

          \ \ }

          \ \ 

          \ \ inline Magma_1 (const Magma_1 &x): rep (x.rep) {

          \ \ \ \ INC_COUNT (rep);

          \ \ }

          \ \ 

          \ \ inline Magma_1

          \ \ &operator = (const Magma_1 &x) {

          \ \ \ \ INC_COUNT (x.rep);

          \ \ \ \ DEC_COUNT (rep);

          \ \ \ \ rep = x.rep;

          \ \ \ \ return *this;

          \ \ }

          \ \ 

          \ \ inline Magma_1 (const Magma_1_rep *x):

          \ \ \ \ rep (const_cast\<less\>Magma_1_rep* \<gtr\> (x))

          \ \ {

          \ \ \ \ INC_COUNT (rep);

          \ \ }

          \ \ 

          \ \ inline const Magma_1_rep

          \ \ *operator -\<gtr\> () const {

          \ \ \ \ return rep;

          \ \ }

          };

          \;

          inline Magma_1

          copy (const Magma_1 &x) {

          \ \ return (x.rep-\<gtr\>Clone ());

          }

          \;

          inline Magma_1_rep

          *access (Magma_1 &x) {

          \ \ if (x.rep-\<gtr\>ref_count \<gtr\> 1) x = copy (x);

          \ \ return x.rep;

          }

          \;

          inline bool

          operator == (const Magma_1 &x, const Magma_1 &y) {

          \ \ return x.rep == y.rep;

          }

          \;

          inline bool

          operator != (const Magma_1 &x, const Magma_1 &y) {

          \ \ return x.rep != y.rep;

          }

          \;

          inline bool

          exact_eq (const Magma_1 &x, const Magma_1 &y) {

          \ \ return x.rep == y.rep;

          }

          \;

          inline bool

          exact_neq (const Magma_1 &x, const Magma_1 &y) {

          \ \ return x.rep != y.rep;

          }

          \;

          inline bool

          hard_eq (const Magma_1 &x, const Magma_1 &y) {

          \ \ return x.rep == y.rep;

          }

          \;

          inline bool

          hard_neq (const Magma_1 &x, const Magma_1 &y) {

          \ \ return x.rep != y.rep;

          }

          \;

          inline nat

          hash (const Magma_1 &x) {

          \ \ return as_hash (x.rep);

          }

          \;

          inline nat

          exact_hash (const Magma_1 &x) {

          \ \ return as_hash (x.rep);

          }

          \;

          inline nat

          hard_hash (const Magma_1 &x) {

          \ \ return as_hash (x.rep);

          }
        </small>
      </cpp-code>
    </hidden>>
  </hidden>|<\hidden>
    <tit|Efficiency: implementation of categories II>

    <\mmx-code>
      forall (R: Magma)

      cube (x: R): R == x * x * x;
    </mmx-code>

    <switch|<\shown>
      <strong|Concrete magma representation class>

      <\cpp-code>
        <\small>
          struct Int_Magma_pGY1_rep: public Magma_1_rep {

          \ \ Magma_EL_1

          \ \ sample_1 () const {

          \ \ \ \ return concrete_to_abstract\<less\>int, Magma_EL_1 \<gtr\>
          (int ());

          \ \ }

          \ \ 

          \ \ Magma_EL_1

          \ \ TT_1 (const Magma_EL_1 &ARGA1_1, const Magma_EL_1 &ARGA2_1)
          const {

          \ \ \ \ return concrete_to_abstract\<less\>int, Magma_EL_1 \<gtr\>\ 

          \ \ \ \ \ \ (abstract_to_concrete\<less\>Magma_EL_1, int \<gtr\>
          (ARGA1_1) *

          \ \ \ \ \ \ \ abstract_to_concrete\<less\>Magma_EL_1, int \<gtr\>
          (ARGA2_1));

          \ \ }

          \ \ 

          \ \ inline Int_Magma_pGY1_rep () {}

          };

          \;

          Magma_1

          Int_Magma_pGY1 () {

          \ \ return Magma_1 (new Int_Magma_pGY1_rep ());

          }
        </small>
      </cpp-code>
    </shown>|<\hidden>
      <strong|The generic cube function>

      <\cpp-code>
        <\small>
          struct LAMBDA_NEW_pGY1_rep:

          \ \ public function_1_rep\<less\>Magma_EL_1, const Magma_EL_1&
          \<gtr\>

          {

          \ \ Magma_1 R_1;

          \ \ 

          \ \ Magma_EL_1

          \ \ apply (const Magma_EL_1 &x_1) {

          \ \ \ \ return R_1-\<gtr\>TT_1 (R_1-\<gtr\>TT_1 (x_1, x_1), x_1);

          \ \ }

          \ \ 

          \ \ inline LAMBDA_NEW_pGY1_rep (const Magma_1 &R_1_bis): R_1
          (R_1_bis) {}

          };

          \;

          function_1\<less\>Magma_EL_1, const Magma_EL_1& \<gtr\>

          cube_pGY1 (const Magma_1 &R_1) {

          \ \ return function_1\<less\>Magma_EL_1, const Magma_EL_1& \<gtr\>

          \ \ \ \ (new LAMBDA_NEW_pGY1_rep (R_1));

          }

          \;

          void

          mmx_initialize_GY () {

          \ \ ...

          \ \ mmout \<less\>\<less\> as\<less\>int \<gtr\> (cube_GY1
          (Int_Magma_pGY1 ()) (as\<less\>Magma_EL_1 \<gtr\> (111)))

          \ \ \ \ \ \ \ \ \<less\>\<less\> string ("\\n");

          }
        </small>
      </cpp-code>
    </hidden>>
  </hidden>|<\hidden>
    <tit|Generic instantiation of foreign templates>

    <\mmx-code>
      foreign cpp import {

      \ \ forall (M: Magma) cube: (M, M) -\<gtr\> M == cube;

      }
    </mmx-code>

    <\cpp-code>
      <\small>
        struct Magma_OBJ_1_rep: public rep_struct {

        \ \ Magma_EL_1 val;

        \ \ Magma_1 tp;

        \ \ inline Magma_OBJ_1_rep () {}

        \ \ inline Magma_OBJ_1_rep (const Magma_EL_1 &val_bis,

        \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ const Magma_1
        &tp_bis):

        \ \ \ \ val (val_bis), tp (tp_bis) {}

        };

        \;

        struct Magma_OBJ_1 {

        \ \ Magma_OBJ_1_rep *rep;

        \ \ ...

        };

        \;

        inline Magma_OBJ_1

        operator * (const Magma_OBJ_1 &a1, const Magma_OBJ_1 &a2) {

        \ \ return Magma_OBJ_1 (a1-\<gtr\>tp-\<gtr\>TT_1 (a1-\<gtr\>val,
        a2-\<gtr\>val), a1-\<gtr\>tp);

        }
      </small>
    </cpp-code>
  </hidden>|<\hidden>
    <tit|Programming in the large>

    <\itemize>
      <unroll|<\shown>
        <vspace*|0.5fn><item>No makefiles

        <math|\<rightsquigarrow\>> automatically determine dependencies from
        include instructions
      </shown>|<\hidden*>
        <item>No object files

        <math|\<rightsquigarrow\>> maintain a local cache with object files
      </hidden*>|<\hidden*>
        <item>No main function

        <math|\<rightsquigarrow\>> any file can be the main entry point
      </hidden*>|<\hidden*>
        <item>Little and only global compilation options (<verbatim|--debug>,
        <verbatim|--optimize>)

        <math|\<rightsquigarrow\>> maintain separate caches as a function of
        options
      </hidden*>|<\hidden*>
        <item>Fine grained parallel building

        <math|\<rightsquigarrow\>> independent processes can be spawn at the
        middle of compilation
      </hidden*>>
    </itemize>
  </hidden>|<\hidden>
    <tit|Compiling the compiler>

    <\small>
      <\session|shell|default>
        <\input|Shell] >
          cd $HOME/mathemagix/mmx/
        </input>

        <\input|Shell] >
          source ./set-devel-paths
        </input>

        <\input|Shell] >
          cd mmcompiler/compiler
        </input>

        <\input|Shell] >
          rm -rf $HOME/.mathemagix/mmc
        </input>

        <\input|Shell] >
          mmc --verbose mmc.mmx
        </input>

        <\input|Shell] >
          mmc --optimize --verbose mmc.mmx
        </input>

        <\input|Shell] >
          \;
        </input>
      </session>
    </small>
  </hidden>>
</body>

<\initial>
  <\collection>
    <associate|info-flag|none>
    <associate|language|english>
    <associate|page-screen-top|5mm>
    <associate|preamble|false>
    <associate|sfactor|5>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|Taylor|<tuple|1|?>>
    <associate|auto-1|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|auto-2|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|auto-3|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|auto-4|<tuple|Miscellaneous corrections|?>>
    <associate|auto-5|<tuple|1|?>>
    <associate|comp-props|<tuple|1|?>>
    <associate|corrector-1-tab|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|corrector-2-tab|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|misinterpret-tab|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|posfig|<tuple|7|?>>
    <associate|tfin-t-bound|<tuple|1|?>>
    <associate|trlagr|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|ts-diff1|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|ts-diff2|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|ts-euler|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|ts-gamma|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|ts-transfin|<tuple|1|?>>
    <associate|ts-zeta|<tuple|1|?>>
  </collection>
</references>